/*
 * CarProducer.cpp
 *
 *  Created on: 28.05.2009
 *      Author: ingmar
 */

#include "CarProducer.h"

CarProducer::CarProducer(odemx::base::Simulation& sim, std::string label, odemx::sync::PortTail::Ptr myTail, odemx::random::ContinuousDist* arrival, odemx::random::ContinuousDist* loading):
	Process(sim, label), myTail(myTail), arrival(arrival), loading(loading) {
}

CarProducer::~CarProducer() {
}

int CarProducer::main() {
	while (true) {
		double sample = loading->sample();
		if (sample < 0) {
			sample = 0;
		}
		holdFor(arrival->sample());
		myTail->put(new Car(sample, getSimulation().getTime()));
	}
	return 0;
}
