/*
 * Ferry.h
 *
 *  Created on: 28.05.2009
 *      Author: ingmar
 */

#ifndef FERRY_H_
#define FERRY_H_

#include <odemx/odemx.h>
#include "Car.h"
#include "FerrySimulation.h"
#include <list>

class FerrySimulation;

class Ferry: public odemx::base::Process {

private:
	odemx::sync::Timer* myTimer;
	odemx::sync::PortHead::Ptr dryland;
	odemx::sync::PortHead::Ptr island;
	odemx::random::ContinuousDist* crossing;
	unsigned int maxLoad;
	odemx::base::SimTime maxWaitTime;

	long long throughput;

	std::list<Car*> carList;

	FerrySimulation* ferrysim;

public:
	Ferry(FerrySimulation& sim, odemx::random::ContinuousDist* crossing, unsigned int maxLoad, odemx::base::SimTime maxWaitTime);
	virtual ~Ferry();
	virtual int main();
	odemx::sync::PortTail::Ptr getIslandTail();
	odemx::sync::PortTail::Ptr getDrylandTail();
	long long getThroughput();
};

#endif /* FERRY_H_ */
